# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from thormang3_walking_module_msgs/StepData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import thormang3_walking_module_msgs.msg

class StepData(genpy.Message):
  _md5sum = "5c123ac289a192451dda1d18cbffa1a0"
  _type = "thormang3_walking_module_msgs/StepData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## the step data for thormang3, composed of position and time data

StepPositionData position_data
StepTimeData     time_data
================================================================================
MSG: thormang3_walking_module_msgs/StepPositionData
#### Step Position Data

## MovingFootFlag
int16 moving_foot

int16 LEFT_FOOT_SWING  = 1 # Left foot constant
int16 RIGHT_FOOT_SWING = 2 # Right foot constant
int16 STANDING         = 3 # No foot constant

## Unit [meter, rad]
float32     foot_z_swap
float32     body_z_swap
float32     x_zmp_shift
float32     y_zmp_shift
float32     torso_yaw_angle_rad
PoseXYZRPY  left_foot_pose
PoseXYZRPY  right_foot_pose
PoseZRPY    body_pose
================================================================================
MSG: thormang3_walking_module_msgs/PoseXYZRPY
float32 x
float32 y
float32 z
float32 roll
float32 pitch
float32 yaw
================================================================================
MSG: thormang3_walking_module_msgs/PoseZRPY
float32 z
float32 roll
float32 pitch
float32 yaw
================================================================================
MSG: thormang3_walking_module_msgs/StepTimeData
#### StepTimeData

## WalkingStateFlag
int16   walking_state

int16 IN_WALKING_STARTING = 0 #WalkingStarting
int16 IN_WALKING          = 1 #Walking
int16 IN_WALKING_ENDING   = 2 #WalkingEnding

## Unit [sec]
float32 abs_step_time #global time

# dsp_ratio >= 0.0 dsp_ratio < 1.0, recommend value is 0.2 
float32 dsp_ratio

# 0.0 <= start_time_delay_ratio    < 1.0
# 0.0 <= finish_time_advance_ratio < 1.0
# 0.0 <= start_time_delay_ratio +  finish_time_advance_ratio < 1.0
# default value is 0.0
float32 start_time_delay_ratio_x
float32 start_time_delay_ratio_y
float32 start_time_delay_ratio_z
float32 start_time_delay_ratio_roll
float32 start_time_delay_ratio_pitch
float32 start_time_delay_ratio_yaw
float32 finish_time_advance_ratio_x
float32 finish_time_advance_ratio_y
float32 finish_time_advance_ratio_z
float32 finish_time_advance_ratio_roll
float32 finish_time_advance_ratio_pitch
float32 finish_time_advance_ratio_yaw"""
  __slots__ = ['position_data','time_data']
  _slot_types = ['thormang3_walking_module_msgs/StepPositionData','thormang3_walking_module_msgs/StepTimeData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       position_data,time_data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StepData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.position_data is None:
        self.position_data = thormang3_walking_module_msgs.msg.StepPositionData()
      if self.time_data is None:
        self.time_data = thormang3_walking_module_msgs.msg.StepTimeData()
    else:
      self.position_data = thormang3_walking_module_msgs.msg.StepPositionData()
      self.time_data = thormang3_walking_module_msgs.msg.StepTimeData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_h21fh14f().pack(_x.position_data.moving_foot, _x.position_data.foot_z_swap, _x.position_data.body_z_swap, _x.position_data.x_zmp_shift, _x.position_data.y_zmp_shift, _x.position_data.torso_yaw_angle_rad, _x.position_data.left_foot_pose.x, _x.position_data.left_foot_pose.y, _x.position_data.left_foot_pose.z, _x.position_data.left_foot_pose.roll, _x.position_data.left_foot_pose.pitch, _x.position_data.left_foot_pose.yaw, _x.position_data.right_foot_pose.x, _x.position_data.right_foot_pose.y, _x.position_data.right_foot_pose.z, _x.position_data.right_foot_pose.roll, _x.position_data.right_foot_pose.pitch, _x.position_data.right_foot_pose.yaw, _x.position_data.body_pose.z, _x.position_data.body_pose.roll, _x.position_data.body_pose.pitch, _x.position_data.body_pose.yaw, _x.time_data.walking_state, _x.time_data.abs_step_time, _x.time_data.dsp_ratio, _x.time_data.start_time_delay_ratio_x, _x.time_data.start_time_delay_ratio_y, _x.time_data.start_time_delay_ratio_z, _x.time_data.start_time_delay_ratio_roll, _x.time_data.start_time_delay_ratio_pitch, _x.time_data.start_time_delay_ratio_yaw, _x.time_data.finish_time_advance_ratio_x, _x.time_data.finish_time_advance_ratio_y, _x.time_data.finish_time_advance_ratio_z, _x.time_data.finish_time_advance_ratio_roll, _x.time_data.finish_time_advance_ratio_pitch, _x.time_data.finish_time_advance_ratio_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.position_data is None:
        self.position_data = thormang3_walking_module_msgs.msg.StepPositionData()
      if self.time_data is None:
        self.time_data = thormang3_walking_module_msgs.msg.StepTimeData()
      end = 0
      _x = self
      start = end
      end += 144
      (_x.position_data.moving_foot, _x.position_data.foot_z_swap, _x.position_data.body_z_swap, _x.position_data.x_zmp_shift, _x.position_data.y_zmp_shift, _x.position_data.torso_yaw_angle_rad, _x.position_data.left_foot_pose.x, _x.position_data.left_foot_pose.y, _x.position_data.left_foot_pose.z, _x.position_data.left_foot_pose.roll, _x.position_data.left_foot_pose.pitch, _x.position_data.left_foot_pose.yaw, _x.position_data.right_foot_pose.x, _x.position_data.right_foot_pose.y, _x.position_data.right_foot_pose.z, _x.position_data.right_foot_pose.roll, _x.position_data.right_foot_pose.pitch, _x.position_data.right_foot_pose.yaw, _x.position_data.body_pose.z, _x.position_data.body_pose.roll, _x.position_data.body_pose.pitch, _x.position_data.body_pose.yaw, _x.time_data.walking_state, _x.time_data.abs_step_time, _x.time_data.dsp_ratio, _x.time_data.start_time_delay_ratio_x, _x.time_data.start_time_delay_ratio_y, _x.time_data.start_time_delay_ratio_z, _x.time_data.start_time_delay_ratio_roll, _x.time_data.start_time_delay_ratio_pitch, _x.time_data.start_time_delay_ratio_yaw, _x.time_data.finish_time_advance_ratio_x, _x.time_data.finish_time_advance_ratio_y, _x.time_data.finish_time_advance_ratio_z, _x.time_data.finish_time_advance_ratio_roll, _x.time_data.finish_time_advance_ratio_pitch, _x.time_data.finish_time_advance_ratio_yaw,) = _get_struct_h21fh14f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_h21fh14f().pack(_x.position_data.moving_foot, _x.position_data.foot_z_swap, _x.position_data.body_z_swap, _x.position_data.x_zmp_shift, _x.position_data.y_zmp_shift, _x.position_data.torso_yaw_angle_rad, _x.position_data.left_foot_pose.x, _x.position_data.left_foot_pose.y, _x.position_data.left_foot_pose.z, _x.position_data.left_foot_pose.roll, _x.position_data.left_foot_pose.pitch, _x.position_data.left_foot_pose.yaw, _x.position_data.right_foot_pose.x, _x.position_data.right_foot_pose.y, _x.position_data.right_foot_pose.z, _x.position_data.right_foot_pose.roll, _x.position_data.right_foot_pose.pitch, _x.position_data.right_foot_pose.yaw, _x.position_data.body_pose.z, _x.position_data.body_pose.roll, _x.position_data.body_pose.pitch, _x.position_data.body_pose.yaw, _x.time_data.walking_state, _x.time_data.abs_step_time, _x.time_data.dsp_ratio, _x.time_data.start_time_delay_ratio_x, _x.time_data.start_time_delay_ratio_y, _x.time_data.start_time_delay_ratio_z, _x.time_data.start_time_delay_ratio_roll, _x.time_data.start_time_delay_ratio_pitch, _x.time_data.start_time_delay_ratio_yaw, _x.time_data.finish_time_advance_ratio_x, _x.time_data.finish_time_advance_ratio_y, _x.time_data.finish_time_advance_ratio_z, _x.time_data.finish_time_advance_ratio_roll, _x.time_data.finish_time_advance_ratio_pitch, _x.time_data.finish_time_advance_ratio_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.position_data is None:
        self.position_data = thormang3_walking_module_msgs.msg.StepPositionData()
      if self.time_data is None:
        self.time_data = thormang3_walking_module_msgs.msg.StepTimeData()
      end = 0
      _x = self
      start = end
      end += 144
      (_x.position_data.moving_foot, _x.position_data.foot_z_swap, _x.position_data.body_z_swap, _x.position_data.x_zmp_shift, _x.position_data.y_zmp_shift, _x.position_data.torso_yaw_angle_rad, _x.position_data.left_foot_pose.x, _x.position_data.left_foot_pose.y, _x.position_data.left_foot_pose.z, _x.position_data.left_foot_pose.roll, _x.position_data.left_foot_pose.pitch, _x.position_data.left_foot_pose.yaw, _x.position_data.right_foot_pose.x, _x.position_data.right_foot_pose.y, _x.position_data.right_foot_pose.z, _x.position_data.right_foot_pose.roll, _x.position_data.right_foot_pose.pitch, _x.position_data.right_foot_pose.yaw, _x.position_data.body_pose.z, _x.position_data.body_pose.roll, _x.position_data.body_pose.pitch, _x.position_data.body_pose.yaw, _x.time_data.walking_state, _x.time_data.abs_step_time, _x.time_data.dsp_ratio, _x.time_data.start_time_delay_ratio_x, _x.time_data.start_time_delay_ratio_y, _x.time_data.start_time_delay_ratio_z, _x.time_data.start_time_delay_ratio_roll, _x.time_data.start_time_delay_ratio_pitch, _x.time_data.start_time_delay_ratio_yaw, _x.time_data.finish_time_advance_ratio_x, _x.time_data.finish_time_advance_ratio_y, _x.time_data.finish_time_advance_ratio_z, _x.time_data.finish_time_advance_ratio_roll, _x.time_data.finish_time_advance_ratio_pitch, _x.time_data.finish_time_advance_ratio_yaw,) = _get_struct_h21fh14f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h21fh14f = None
def _get_struct_h21fh14f():
    global _struct_h21fh14f
    if _struct_h21fh14f is None:
        _struct_h21fh14f = struct.Struct("<h21fh14f")
    return _struct_h21fh14f
