# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from thormang3_walking_module_msgs/StepPositionData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import thormang3_walking_module_msgs.msg

class StepPositionData(genpy.Message):
  _md5sum = "88a7ca881b40058b9b8edc224fb86a74"
  _type = "thormang3_walking_module_msgs/StepPositionData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#### Step Position Data

## MovingFootFlag
int16 moving_foot

int16 LEFT_FOOT_SWING  = 1 # Left foot constant
int16 RIGHT_FOOT_SWING = 2 # Right foot constant
int16 STANDING         = 3 # No foot constant

## Unit [meter, rad]
float32     foot_z_swap
float32     body_z_swap
float32     x_zmp_shift
float32     y_zmp_shift
float32     torso_yaw_angle_rad
PoseXYZRPY  left_foot_pose
PoseXYZRPY  right_foot_pose
PoseZRPY    body_pose
================================================================================
MSG: thormang3_walking_module_msgs/PoseXYZRPY
float32 x
float32 y
float32 z
float32 roll
float32 pitch
float32 yaw
================================================================================
MSG: thormang3_walking_module_msgs/PoseZRPY
float32 z
float32 roll
float32 pitch
float32 yaw"""
  # Pseudo-constants
  LEFT_FOOT_SWING = 1
  RIGHT_FOOT_SWING = 2
  STANDING = 3

  __slots__ = ['moving_foot','foot_z_swap','body_z_swap','x_zmp_shift','y_zmp_shift','torso_yaw_angle_rad','left_foot_pose','right_foot_pose','body_pose']
  _slot_types = ['int16','float32','float32','float32','float32','float32','thormang3_walking_module_msgs/PoseXYZRPY','thormang3_walking_module_msgs/PoseXYZRPY','thormang3_walking_module_msgs/PoseZRPY']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       moving_foot,foot_z_swap,body_z_swap,x_zmp_shift,y_zmp_shift,torso_yaw_angle_rad,left_foot_pose,right_foot_pose,body_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StepPositionData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.moving_foot is None:
        self.moving_foot = 0
      if self.foot_z_swap is None:
        self.foot_z_swap = 0.
      if self.body_z_swap is None:
        self.body_z_swap = 0.
      if self.x_zmp_shift is None:
        self.x_zmp_shift = 0.
      if self.y_zmp_shift is None:
        self.y_zmp_shift = 0.
      if self.torso_yaw_angle_rad is None:
        self.torso_yaw_angle_rad = 0.
      if self.left_foot_pose is None:
        self.left_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      if self.right_foot_pose is None:
        self.right_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      if self.body_pose is None:
        self.body_pose = thormang3_walking_module_msgs.msg.PoseZRPY()
    else:
      self.moving_foot = 0
      self.foot_z_swap = 0.
      self.body_z_swap = 0.
      self.x_zmp_shift = 0.
      self.y_zmp_shift = 0.
      self.torso_yaw_angle_rad = 0.
      self.left_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      self.right_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      self.body_pose = thormang3_walking_module_msgs.msg.PoseZRPY()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_h21f().pack(_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad, _x.left_foot_pose.x, _x.left_foot_pose.y, _x.left_foot_pose.z, _x.left_foot_pose.roll, _x.left_foot_pose.pitch, _x.left_foot_pose.yaw, _x.right_foot_pose.x, _x.right_foot_pose.y, _x.right_foot_pose.z, _x.right_foot_pose.roll, _x.right_foot_pose.pitch, _x.right_foot_pose.yaw, _x.body_pose.z, _x.body_pose.roll, _x.body_pose.pitch, _x.body_pose.yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.left_foot_pose is None:
        self.left_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      if self.right_foot_pose is None:
        self.right_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      if self.body_pose is None:
        self.body_pose = thormang3_walking_module_msgs.msg.PoseZRPY()
      end = 0
      _x = self
      start = end
      end += 86
      (_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad, _x.left_foot_pose.x, _x.left_foot_pose.y, _x.left_foot_pose.z, _x.left_foot_pose.roll, _x.left_foot_pose.pitch, _x.left_foot_pose.yaw, _x.right_foot_pose.x, _x.right_foot_pose.y, _x.right_foot_pose.z, _x.right_foot_pose.roll, _x.right_foot_pose.pitch, _x.right_foot_pose.yaw, _x.body_pose.z, _x.body_pose.roll, _x.body_pose.pitch, _x.body_pose.yaw,) = _get_struct_h21f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_h21f().pack(_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad, _x.left_foot_pose.x, _x.left_foot_pose.y, _x.left_foot_pose.z, _x.left_foot_pose.roll, _x.left_foot_pose.pitch, _x.left_foot_pose.yaw, _x.right_foot_pose.x, _x.right_foot_pose.y, _x.right_foot_pose.z, _x.right_foot_pose.roll, _x.right_foot_pose.pitch, _x.right_foot_pose.yaw, _x.body_pose.z, _x.body_pose.roll, _x.body_pose.pitch, _x.body_pose.yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.left_foot_pose is None:
        self.left_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      if self.right_foot_pose is None:
        self.right_foot_pose = thormang3_walking_module_msgs.msg.PoseXYZRPY()
      if self.body_pose is None:
        self.body_pose = thormang3_walking_module_msgs.msg.PoseZRPY()
      end = 0
      _x = self
      start = end
      end += 86
      (_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad, _x.left_foot_pose.x, _x.left_foot_pose.y, _x.left_foot_pose.z, _x.left_foot_pose.roll, _x.left_foot_pose.pitch, _x.left_foot_pose.yaw, _x.right_foot_pose.x, _x.right_foot_pose.y, _x.right_foot_pose.z, _x.right_foot_pose.roll, _x.right_foot_pose.pitch, _x.right_foot_pose.yaw, _x.body_pose.z, _x.body_pose.roll, _x.body_pose.pitch, _x.body_pose.yaw,) = _get_struct_h21f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h21f = None
def _get_struct_h21f():
    global _struct_h21f
    if _struct_h21f is None:
        _struct_h21f = struct.Struct("<h21f")
    return _struct_h21f
