# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from thormang3_walking_module_msgs/AddStepDataArrayRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import thormang3_walking_module_msgs.msg

class AddStepDataArrayRequest(genpy.Message):
  _md5sum = "ceb2a926f880ff0d3107efdc25c41f8c"
  _type = "thormang3_walking_module_msgs/AddStepDataArrayRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool       auto_start
bool       remove_existing_step_data
StepData[] step_data_array

================================================================================
MSG: thormang3_walking_module_msgs/StepData
## the step data for thormang3, composed of position and time data

StepPositionData position_data
StepTimeData     time_data
================================================================================
MSG: thormang3_walking_module_msgs/StepPositionData
#### Step Position Data

## MovingFootFlag
int16 moving_foot

int16 LEFT_FOOT_SWING  = 1 # Left foot constant
int16 RIGHT_FOOT_SWING = 2 # Right foot constant
int16 STANDING         = 3 # No foot constant

## Unit [meter, rad]
float32     foot_z_swap
float32     body_z_swap
float32     x_zmp_shift
float32     y_zmp_shift
float32     torso_yaw_angle_rad
PoseXYZRPY  left_foot_pose
PoseXYZRPY  right_foot_pose
PoseZRPY    body_pose
================================================================================
MSG: thormang3_walking_module_msgs/PoseXYZRPY
float32 x
float32 y
float32 z
float32 roll
float32 pitch
float32 yaw
================================================================================
MSG: thormang3_walking_module_msgs/PoseZRPY
float32 z
float32 roll
float32 pitch
float32 yaw
================================================================================
MSG: thormang3_walking_module_msgs/StepTimeData
#### StepTimeData

## WalkingStateFlag
int16   walking_state

int16 IN_WALKING_STARTING = 0 #WalkingStarting
int16 IN_WALKING          = 1 #Walking
int16 IN_WALKING_ENDING   = 2 #WalkingEnding

## Unit [sec]
float32 abs_step_time #global time

# dsp_ratio >= 0.0 dsp_ratio < 1.0, recommend value is 0.2 
float32 dsp_ratio

# 0.0 <= start_time_delay_ratio    < 1.0
# 0.0 <= finish_time_advance_ratio < 1.0
# 0.0 <= start_time_delay_ratio +  finish_time_advance_ratio < 1.0
# default value is 0.0
float32 start_time_delay_ratio_x
float32 start_time_delay_ratio_y
float32 start_time_delay_ratio_z
float32 start_time_delay_ratio_roll
float32 start_time_delay_ratio_pitch
float32 start_time_delay_ratio_yaw
float32 finish_time_advance_ratio_x
float32 finish_time_advance_ratio_y
float32 finish_time_advance_ratio_z
float32 finish_time_advance_ratio_roll
float32 finish_time_advance_ratio_pitch
float32 finish_time_advance_ratio_yaw"""
  __slots__ = ['auto_start','remove_existing_step_data','step_data_array']
  _slot_types = ['bool','bool','thormang3_walking_module_msgs/StepData[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       auto_start,remove_existing_step_data,step_data_array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddStepDataArrayRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.auto_start is None:
        self.auto_start = False
      if self.remove_existing_step_data is None:
        self.remove_existing_step_data = False
      if self.step_data_array is None:
        self.step_data_array = []
    else:
      self.auto_start = False
      self.remove_existing_step_data = False
      self.step_data_array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.auto_start, _x.remove_existing_step_data))
      length = len(self.step_data_array)
      buff.write(_struct_I.pack(length))
      for val1 in self.step_data_array:
        _v1 = val1.position_data
        _x = _v1
        buff.write(_get_struct_h5f().pack(_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad))
        _v2 = _v1.left_foot_pose
        _x = _v2
        buff.write(_get_struct_6f().pack(_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw))
        _v3 = _v1.right_foot_pose
        _x = _v3
        buff.write(_get_struct_6f().pack(_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw))
        _v4 = _v1.body_pose
        _x = _v4
        buff.write(_get_struct_4f().pack(_x.z, _x.roll, _x.pitch, _x.yaw))
        _v5 = val1.time_data
        _x = _v5
        buff.write(_get_struct_h14f().pack(_x.walking_state, _x.abs_step_time, _x.dsp_ratio, _x.start_time_delay_ratio_x, _x.start_time_delay_ratio_y, _x.start_time_delay_ratio_z, _x.start_time_delay_ratio_roll, _x.start_time_delay_ratio_pitch, _x.start_time_delay_ratio_yaw, _x.finish_time_advance_ratio_x, _x.finish_time_advance_ratio_y, _x.finish_time_advance_ratio_z, _x.finish_time_advance_ratio_roll, _x.finish_time_advance_ratio_pitch, _x.finish_time_advance_ratio_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.step_data_array is None:
        self.step_data_array = None
      end = 0
      _x = self
      start = end
      end += 2
      (_x.auto_start, _x.remove_existing_step_data,) = _get_struct_2B().unpack(str[start:end])
      self.auto_start = bool(self.auto_start)
      self.remove_existing_step_data = bool(self.remove_existing_step_data)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.step_data_array = []
      for i in range(0, length):
        val1 = thormang3_walking_module_msgs.msg.StepData()
        _v6 = val1.position_data
        _x = _v6
        start = end
        end += 22
        (_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad,) = _get_struct_h5f().unpack(str[start:end])
        _v7 = _v6.left_foot_pose
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw,) = _get_struct_6f().unpack(str[start:end])
        _v8 = _v6.right_foot_pose
        _x = _v8
        start = end
        end += 24
        (_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw,) = _get_struct_6f().unpack(str[start:end])
        _v9 = _v6.body_pose
        _x = _v9
        start = end
        end += 16
        (_x.z, _x.roll, _x.pitch, _x.yaw,) = _get_struct_4f().unpack(str[start:end])
        _v10 = val1.time_data
        _x = _v10
        start = end
        end += 58
        (_x.walking_state, _x.abs_step_time, _x.dsp_ratio, _x.start_time_delay_ratio_x, _x.start_time_delay_ratio_y, _x.start_time_delay_ratio_z, _x.start_time_delay_ratio_roll, _x.start_time_delay_ratio_pitch, _x.start_time_delay_ratio_yaw, _x.finish_time_advance_ratio_x, _x.finish_time_advance_ratio_y, _x.finish_time_advance_ratio_z, _x.finish_time_advance_ratio_roll, _x.finish_time_advance_ratio_pitch, _x.finish_time_advance_ratio_yaw,) = _get_struct_h14f().unpack(str[start:end])
        self.step_data_array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.auto_start, _x.remove_existing_step_data))
      length = len(self.step_data_array)
      buff.write(_struct_I.pack(length))
      for val1 in self.step_data_array:
        _v11 = val1.position_data
        _x = _v11
        buff.write(_get_struct_h5f().pack(_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad))
        _v12 = _v11.left_foot_pose
        _x = _v12
        buff.write(_get_struct_6f().pack(_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw))
        _v13 = _v11.right_foot_pose
        _x = _v13
        buff.write(_get_struct_6f().pack(_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw))
        _v14 = _v11.body_pose
        _x = _v14
        buff.write(_get_struct_4f().pack(_x.z, _x.roll, _x.pitch, _x.yaw))
        _v15 = val1.time_data
        _x = _v15
        buff.write(_get_struct_h14f().pack(_x.walking_state, _x.abs_step_time, _x.dsp_ratio, _x.start_time_delay_ratio_x, _x.start_time_delay_ratio_y, _x.start_time_delay_ratio_z, _x.start_time_delay_ratio_roll, _x.start_time_delay_ratio_pitch, _x.start_time_delay_ratio_yaw, _x.finish_time_advance_ratio_x, _x.finish_time_advance_ratio_y, _x.finish_time_advance_ratio_z, _x.finish_time_advance_ratio_roll, _x.finish_time_advance_ratio_pitch, _x.finish_time_advance_ratio_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.step_data_array is None:
        self.step_data_array = None
      end = 0
      _x = self
      start = end
      end += 2
      (_x.auto_start, _x.remove_existing_step_data,) = _get_struct_2B().unpack(str[start:end])
      self.auto_start = bool(self.auto_start)
      self.remove_existing_step_data = bool(self.remove_existing_step_data)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.step_data_array = []
      for i in range(0, length):
        val1 = thormang3_walking_module_msgs.msg.StepData()
        _v16 = val1.position_data
        _x = _v16
        start = end
        end += 22
        (_x.moving_foot, _x.foot_z_swap, _x.body_z_swap, _x.x_zmp_shift, _x.y_zmp_shift, _x.torso_yaw_angle_rad,) = _get_struct_h5f().unpack(str[start:end])
        _v17 = _v16.left_foot_pose
        _x = _v17
        start = end
        end += 24
        (_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw,) = _get_struct_6f().unpack(str[start:end])
        _v18 = _v16.right_foot_pose
        _x = _v18
        start = end
        end += 24
        (_x.x, _x.y, _x.z, _x.roll, _x.pitch, _x.yaw,) = _get_struct_6f().unpack(str[start:end])
        _v19 = _v16.body_pose
        _x = _v19
        start = end
        end += 16
        (_x.z, _x.roll, _x.pitch, _x.yaw,) = _get_struct_4f().unpack(str[start:end])
        _v20 = val1.time_data
        _x = _v20
        start = end
        end += 58
        (_x.walking_state, _x.abs_step_time, _x.dsp_ratio, _x.start_time_delay_ratio_x, _x.start_time_delay_ratio_y, _x.start_time_delay_ratio_z, _x.start_time_delay_ratio_roll, _x.start_time_delay_ratio_pitch, _x.start_time_delay_ratio_yaw, _x.finish_time_advance_ratio_x, _x.finish_time_advance_ratio_y, _x.finish_time_advance_ratio_z, _x.finish_time_advance_ratio_roll, _x.finish_time_advance_ratio_pitch, _x.finish_time_advance_ratio_yaw,) = _get_struct_h14f().unpack(str[start:end])
        self.step_data_array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_h5f = None
def _get_struct_h5f():
    global _struct_h5f
    if _struct_h5f is None:
        _struct_h5f = struct.Struct("<h5f")
    return _struct_h5f
_struct_6f = None
def _get_struct_6f():
    global _struct_6f
    if _struct_6f is None:
        _struct_6f = struct.Struct("<6f")
    return _struct_6f
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_h14f = None
def _get_struct_h14f():
    global _struct_h14f
    if _struct_h14f is None:
        _struct_h14f = struct.Struct("<h14f")
    return _struct_h14f
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from thormang3_walking_module_msgs/AddStepDataArrayResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddStepDataArrayResponse(genpy.Message):
  _md5sum = "0f88c15da5fc32c19b6aa84196f9ee87"
  _type = "thormang3_walking_module_msgs/AddStepDataArrayResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """int32 result

int32 NO_ERROR                   = 0
int32 NOT_ENABLED_WALKING_MODULE = 2
int32 PROBLEM_IN_POSITION_DATA   = 4
int32 PROBLEM_IN_TIME_DATA       = 8

int32 TOO_MANY_STEP_DATA         = 128

int32 ROBOT_IS_WALKING_NOW       = 1024
"""
  # Pseudo-constants
  NO_ERROR = 0
  NOT_ENABLED_WALKING_MODULE = 2
  PROBLEM_IN_POSITION_DATA = 4
  PROBLEM_IN_TIME_DATA = 8
  TOO_MANY_STEP_DATA = 128
  ROBOT_IS_WALKING_NOW = 1024

  __slots__ = ['result']
  _slot_types = ['int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       result

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddStepDataArrayResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.result is None:
        self.result = 0
    else:
      self.result = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_get_struct_i().pack(self.result))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 4
      (self.result,) = _get_struct_i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_get_struct_i().pack(self.result))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 4
      (self.result,) = _get_struct_i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
class AddStepDataArray(object):
  _type          = 'thormang3_walking_module_msgs/AddStepDataArray'
  _md5sum = 'c442393931ce1550ef985f36a475a22a'
  _request_class  = AddStepDataArrayRequest
  _response_class = AddStepDataArrayResponse
